#include <stdio.h>

char ftc[40],cf[40];

typedef struct
{
  unsigned char a;
  long int size;
  int tabno;
  int code[17];
}dat;

unsigned char r; 
dat data[256];
long int siz; 
int buf[8]; 
unsigned char w;

void q2sort(int head,int tail)
{
	int in,h,t;
	int d;
	dat a;

	h=head;
	t=tail;
	while(1)
	{
		while(data[head].size>=data[tail].size && head<tail)
			head++;
		while(data[tail].size<=data[head].size && tail>head)
			tail--;
		if(head>=tail) break;
		a=data[head];
		data[head]=data[tail];
		data[tail]=a;
	}
	d=t-h;
	if(d<1)	return;
	else if(d==1)
	{
		if(data[t].size>data[h].size)
		{
			a=data[h];
			data[h]=data[t];
			data[t]=a;
		}
		return;
 	}
	q2sort(h,head-1);
	q2sort(tail,t);
}

void xtract()
{
	FILE *f1;
	int re, i;
 	dat a[256];
 	int sto[256];
 	int m, c;

 	if ( (f1 = fopen(ftc,"r")) == NULL ) 
	{
		printf("Erro na abertura do arquivo %s...\n",ftc);
		exit(0);
	}

 	re=0;

 	while(ftc[re]!='.')
  	{
  			cf[re] =ftc[re];
  			re++;
  	}
  	cf[re]= '.';
  	cf[re+1] = 'c';
  	cf[re+2] = 'm';
  	cf[re+3] = 'm';
  	cf[re+4] = '\0';

 	siz=1;

 	r=fgetc(f1);
 	a[(int)r].a=r;

 	for(i=0;i<256;i++)
   	a[i].size =0;

 	m =(int)r;
 	a[m].size= 1;
	c=0;
 	sto[c]= (int)r;
   c++;

 	while(!feof(f1))
  	{
		r=fgetc(f1);
    	m =(int)r;
    	if(a[m].size!=0)
	  		a[m].size++;
	  	else
    	{
     		a[m].a = r;
     		a[m].size=1;
     		sto[c]=(int)r;
     		c++;
     		siz++;
     	}

  	}
  	for( i=0;i<siz;i++)
   	data[i]= a[sto[i]];

  	q2sort(0,siz-1);
  	fclose(f1);
}

void assign_table()
{
  	int row[10],element,notab,ctab,k,i,j;
	FILE *f2;

  	element=0;notab=0;ctab=0;

   for(k=0;k<10;k++)
   	row[k]=0;

 	j=0;
 	for(i=0;j<siz;i++)
 	{
		if(element<row[ctab]+2)
	 	{
		 	data[j].tabno= ctab;
		  	element++;
		  	j++;
		}
	   else
		{
		 	row[ctab]++;

			if(ctab<notab)
		  	{
		  		ctab++;
		  		element=0;
		  		continue;
		  	}
		  	if(ctab==notab)
		  	{
		  		if(row[ctab]<=2)
		  		{
		    		ctab=0;
		     		element=0;
		    	}
		    	else
		    	{
		     		ctab++;notab++;
		     		element=0;
		     	}
		  	}
		}
	}
	if ( (f2 = fopen(cf,"wb")) == NULL )
	{	
		printf("Erro na criacao do arquivo %s ...\n",cf);
		exit(0);
	}

	for(i=0;i<siz;i++)
		fwrite(&data[i].a, sizeof(char), 1, f2);
	fclose(f2);
}

void code_gen()
{
 	int m=0;int n=0;int track1=1,track2=0,id;
	int rows[20];
  	int i,j,h,k,l;

  	for(i=0;i<20;i++)
   	rows[i]=1;
   		
	while(m<siz)
  	{
   	i=0;
     	for(j= track1;j>=0&&m<siz;j--)
      {
			n=0;

	     	for(h=0;h<track2;h++)
	     	{
				data[m].code[n++]=1;
				data[m].code[n++]=1;
			}

	     	for(k=0;k<i;k++)
				data[m].code[n++]=0;

	     	data[m].code[n]=1;n++;
	     	for(l=0;l<j;l++)
				data[m].code[n++]=0;

	     	data[m].code[n++]=1; 
	     	data[m].code[n]=2;

	     	i++;
	     	m++;

   		if(data[m].tabno!=track2)
  			{
   			rows[track2]++;
				track2=data[m].tabno;
				j=rows[track2]+1;
				i=0;
  			}
 		}
      if(m<9)
			rows[track2]++;
		track1++;

   }
}

int bin_search(char c)
{
   int i,beg,mid,end;
   beg=0;
   end=siz;
   mid = siz/2;
   for(i=0;i<siz&&data[mid].a!=c;i++)
   {
      if(data[mid].a>c)
      {
         end=mid;
         mid = (beg+end)/2;
      }
      else
      {
         beg=mid;
         mid = (beg+end)/2;
      }
   }
   if(data[mid].a==c)
      return(mid);
   else return(-1);
}

void q2sort1(int head,int tail)
{
	int in,h,t,d;
	dat a;
	h=head;
	t=tail;

	while(1)
  	{
		while(data[head].a<=data[tail].a && head<tail)
			head++;
		while(data[tail].a>=data[head].a && tail>head)
			tail--;
		if(head>=tail) break;
		a=data[head];
		data[head]=data[tail];
		data[tail]=a;
	}
	d=t-h;
	if(d<1) return;
	else if(d==1)
	{
		if(data[t].a<data[h].a)
		{
			a=data[h];
			data[h]=data[t];
			data[t]=a;
		}
		return;
	}
	q2sort1(h,head-1);
	q2sort1(tail,t);
}

void code_subs()
{
  	dat temp;
  	FILE *f1,*f2;
  	unsigned char w;
   int dbuf[8];
   int track;
   int track2=0;
   int track1;
	int i,n,wr,bc;

  	q2sort1(0,siz-1);

 	if ( (f1 = fopen(ftc,"rb")) == NULL ) 
	{
		printf("Erro na abertura do arquivo %s...\n",ftc);
		exit(0);
	}
 	if ( (f2 = fopen(cf,"ab")) == NULL ) 
	{
		printf("Erro na abertura do arquivo %s...\n",ftc);
		exit(0);
	}

   r=fgetc(f1);
 	while(!feof(f1))
   {
		track= bin_search(r);
	 	if(track==-1)
			printf("tatatata");

	 	for(n=0;data[track].code[n]!=2;n++)
	  	{
	  		buf[track2]= data[track].code[n];
	  		track2++;
	    	if(track2==8)
	     	{
	      	wr=0;
	      	for(bc=0; bc<8;bc++)
		  		{
		  	 		if(buf[bc])
		   			wr= wr+( buf[bc]<<bc);
		  		}
	      	w = (char)wr;
				fwrite(&w, sizeof(char), 1, f2);
	      	track2=0;
	     	}
	  	}
	 	r=fgetc(f1);
	}
 	if(track2!=0)
 	{
		wr=0;
		for(i=0;i<track2;i++)
		{
			if(buf[i])
	  			wr = wr+(buf[i]<<i);
	 	}
	 	w = (char)wr;
		fwrite(&w, sizeof(char), 1, f2);
	}
   fclose(f1);
   fclose(f2);
}

void main()
{
	printf("Arquivo a ser comprimido :\n");
  	gets(ftc);
  	xtract();
  	assign_table();
  	code_gen();
  	code_subs();
  	printf("\nCompactacao completa !\n");
}
