#include <iostream.h>


class numeros
{
	private:
		int a, b, c;
	public:
		numeros ();
		void atribui (int n1, int n2, int n3);
		void exibe (void);
		numeros operator+ (numeros n);
		numeros operator- (numeros n);
		numeros operator++ ();
		numeros operator-- ();
		numeros numeros::operator++ (int);
		numeros numeros::operator-- (int);
		int valor_a (void);
		int valor_b (void);
		int valor_c (void);
};

void main()
{
	numeros x, z, w;

	cout << "\nAtribuindo valores a X (1,1,1) ...\n";
	x.atribui(1,1,1);
	cout << "\nExibindo o valor de X ...\n";
	x.exibe();
	cout << "\nAtribuindo valores a Z (3,2,1) ...\n";
	z.atribui(3,2,1);
	cout << "\nExibindo o valor de Z ...\n";
	z.exibe();
	cout << "\n";
	cout << "\nSomando X com Z e atribuindo o resultado a W ...\n";
	w = x + z;
	cout << "\nExibindo o valor de W ...\n";
	w.exibe();
	cout << "\nAtribuindo valores a X (3,3,3) ...\n";
	x.atribui(3,3,3);
	cout << "\nSubtraindo X de W e atribuindo o resultado a Z ...\n";
	z = w - x;
	cout << "\nExibindo o valor de Z ...\n";
	z.exibe();
	cout << "\nAuto-incrementando Z...\n";
	z++;
	cout << "\nExibindo o valor de Z ...\n";
	z.exibe();
	cout << "\nAtribuindo o valor de X a W e auto-decrementando X ...\n";
	w= x--;
	cout << "\nExibindo o valor de X ...\n";
	x.exibe();
	cout << "\nExibindo o valor de W ...\n";
	w.exibe();
}

numeros::numeros()
{
	a = 0;
	b = 0;
	c = 0;
}

void numeros::atribui(int n1, int n2, int n3)
{
	a = n1;
	b = n2;
	c = n3;
}

void numeros::exibe(void)
{
	cout << "a = " << a << "\n";
	cout << "b = " << b << "\n";
	cout << "c = " << c << "\n";
}

numeros numeros::operator+ (numeros n)
{
	numeros x;

	x.a = a + n.a;
	x.b = b + n.b;
	x.c = c + n.c;
	return x;
}

numeros numeros::operator++ ()
{
	numeros temp;

	a++;
	b++;
	c++;
	temp.a = a;
	temp.b = b;
	temp.c = c;
	return temp;
}

numeros numeros::operator++ (int)
{
   numeros temp;

   temp.a = a;
   temp.b = b;
   temp.c = c;
   a++;
   b++;
   c++;
   return temp;
}

numeros numeros::operator-- ()
{
	numeros temp;

	a--;
	b--;
	c--;
	temp.a = a;
	temp.b = b;
	temp.c = c;
	return temp;
}

numeros numeros::operator-- (int)
{
   numeros temp;

   temp.a = a;
   temp.b = b;
   temp.c = c;
   a--;
   b--;
   c--;
   return temp;
}

numeros numeros::operator- (numeros n)
{
	numeros x;

	x.a = a - n.a;
	x.b = b - n.b;
	x.c = c - n.c;
	return x;
}

int numeros::valor_a (void)
{
	return a;
}


int numeros::valor_b (void)
{
	return b;
}


int numeros::valor_c (void)
{
	return c;
}